Attribute VB_Name = "frmFile_IO"
Option Explicit

Public Type BROWSEINFO
   hOwner           As Long
   pidlRoot         As Long
   pszDisplayName   As String
   lpszTitle        As String
   ulFlags          As Long
   lpfn             As Long
   lParam           As Long
   iImage           As Long
End Type

Public Const BIF_RETURNONLYFSDIRS = &H1
Public Const BIF_DONTGOBELOWDOMAIN = &H2
Public Const BIF_STATUSTEXT = &H4
Public Const BIF_RETURNFSANCESTORS = &H8
Public Const BIF_BROWSEFORCOMPUTER = &H1000
Public Const BIF_BROWSEFORPRINTER = &H2000
Public Const MAX_PATH = 260

Public Declare Function SHGetPathFromIDList _
   Lib "shell32.dll" Alias "SHGetPathFromIDListA" _
  (ByVal pidl As Long, _
   ByVal pszPath As String) As Long

Public Declare Function SHBrowseForFolder Lib "shell32.dll" _
   Alias "SHBrowseForFolderA" _
  (lpBrowseInfo As BROWSEINFO) As Long

Public Declare Sub CoTaskMemFree Lib "ole32.dll" _
   (ByVal pv As Long)
'--end block--'


'*****************************************************
' But:       Ouvre un fichier
'
' Inputs:    le nom du fichier : gStrNomFich
'
' Returns:   Le contenue du fichier dans frmFeuille.rtfFich
'*****************************************************
Public Function OuvrirFich(strPath As String)
On Error GoTo waiting
  'Charger un fichier
  Dim FichNo As Integer
  FichNo = FreeFile
  'Ouvrir fichier
  
  Open strPath For Input As #FichNo
  'Ouvrir texte format
  OuvrirFich = Input$(LOF(FichNo), FichNo)
  
  Close #FichNo
waiting:
  Exit Function
End Function

'*****************************************************
' But:       Enregistre le fichier
'
' Inputs:    Le nom du fichier : gStrNomFich
'
' Returns:   Rien
'*****************************************************
Public Sub Enregistre(strPath As String, StrUpdatedCode As String)
  Dim FichNo As Integer
  
  'No de fichier libre
  FichNo = FreeFile
  'Ouvrir fichier
  Open strPath For Output As #FichNo
  'Enregistre le fichier
  Print #FichNo, StrUpdatedCode
  'Ferme le fichier
  Close #FichNo

End Sub

'*****************************************************
' But:       Crer un rpertoire, empche une erreur
'            s'il existe dj.
'
' Inputs:    Le nom du rpertoire : Dir_Name
'
' Returns:   Rien
'*****************************************************
Public Sub Create_Dir(Dir_Name As String)
On Error GoTo fin
  MkDir Dir_Name
fin:
End Sub

'*****************************************************
' But:       Efface rpertoire, empche une erreur
'            s'il n'existe pas.
'
' Inputs:    Le nom du rpertoire : Dir_Name
'
' Returns:   Rien
'*****************************************************
Public Sub Delete_File(File_Name As String)
On Error GoTo fin
  Kill File_Name
fin:
End Sub

Public Sub MoveFile(Origin As String, Destination As String)
On Error GoTo Erreur:
  Name Origin As Destination
Erreur:
End Sub

Public Function CallFolderFinder(CurPath As String, Owner As Form) As String
  Dim bi As BROWSEINFO
  Dim pidl As Long
  Dim Path As String
  Dim pos As Integer
  Dim ReturnPath As String
    
  'Label1.Caption = ""

 'Fill the BROWSEINFO structure with the
 'needed data. To accomodate comments, the
 'With/End With sytax has not been used, though
 'it should be your 'final' version.

 'hwnd of the window that receives messages
 'from the call. Can be your application
 'or the handle from GetDesktopWindow().
  bi.hOwner = Owner.hWnd

 'Pointer to the item identifier list specifying
 'the location of the "root" folder to browse from.
 'If NULL, the desktop folder is used.
  bi.pidlRoot = 0&

 'message to be displayed in the Browse dialog
  bi.lpszTitle = "Select your Windows\System\ directory"

 'the type of folder to return.
  bi.ulFlags = BIF_RETURNONLYFSDIRS
  
 'show the browse for folders dialog
  pidl = SHBrowseForFolder(bi)
 
 'the dialog has closed, so parse & display the
 'user's returned folder selection contained in pidl
  Path = Space$(MAX_PATH)
    
  If SHGetPathFromIDList(ByVal pidl, ByVal Path) Then
     pos = InStr(Path, Chr$(0))
     ReturnPath = Left(Path, pos - 1)
  End If

  Call CoTaskMemFree(pidl)
  
  If (Len(ReturnPath) = 0) Then ReturnPath = CurPath
  
  CallFolderFinder = ReturnPath
End Function

