VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Easy_Array"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'The various types of arrays supported :
Dim iArray() As Integer
Dim strArray() As String

'Hold the type of the array curently used
Dim strType As String

'*****************************************************
' But:       It's the constructor
'
' Inputs:    sType : The type of the array
'                    s = string
'                    i = integer
'                    u = unit
'                    w = weapon
'
' Returns:   N/A
'*****************************************************
Public Sub New_Array(sType As String)
  strType = sType
  Clear
End Sub

'*****************************************************
' But:       Empty the array
'
' Inputs:    N/A
'
' Returns:   N/A
'*****************************************************
Public Sub Clear()
  ReDim strArray(0)
  ReDim iArray(0)
  
  'MsgBox UBound(iArray)
End Sub

'*****************************************************
' But:       Adds an item to the array
'
' Inputs:    strItem : Contains the item to add
'            index :   Contains the index number where the new item must be added
'                      The index parameter is optional, if empty it will put it at
'                      then end of the array
'
' Returns:   N/A
'*****************************************************
Public Sub AddItem(strItem As Variant, Optional Index As Integer = -1)
Dim i As Integer
  If Index = -1 Then
    If strType = "s" Then Index = UBound(strArray)
    If strType = "i" Then Index = UBound(iArray)
      
  End If
  
  If strType = "s" Then
    ReDim Preserve strArray(UBound(strArray) + 1)
    TestBounds (Index)
    i = UBound(strArray)
    While (i > Index)
       strArray(i) = strArray(i - 1)
       i = i - 1
    Wend
    strArray(UBound(strArray)) = ""
    'Take care of null terminated strings
On Error GoTo Erreur:
       strItem = Left(strItem, InStr(strItem, Chr(0)) - 1)
Erreur:
    strArray(Index) = strItem
  End If
  
  If strType = "i" Then
    ReDim Preserve iArray(UBound(iArray) + 1)
    TestBounds (Index)
    i = UBound(iArray)
    While (i > Index)
       iArray(i) = iArray(i - 1)
       i = i - 1
    Wend
    iArray(UBound(iArray)) = ""
    
    iArray(Index) = Val(strItem)
  End If


End Sub

'*****************************************************
' But:       Return an object in the array
'
' Inputs:    index : The index number of the item to be returned
'
' Returns:   List : Contain the returned item
'*****************************************************
Public Function List(Index As Integer)
  'TestBounds (index)
  If strType = "s" Then
    If Index > ListCount() - 1 Then
      List = ""
    Else
      List = strArray(Index)
    End If
  End If
  
  If strType = "i" Then
    If Index > ListCount() - 1 Then
      List = 0
    Else
      List = iArray(Index)
    End If
  End If
  
  
End Function

'*****************************************************
' But:       Counts the number of items in the array
'
' Inputs:    N/A
'
' Returns:   N/A
'*****************************************************
Public Function ListCount() As Integer
  If strType = "s" Then
    ListCount = UBound(strArray)
  End If
  
  If strType = "i" Then
    ListCount = UBound(iArray)
  End If
 
 
End Function

'*****************************************************
' But:       Removes an item in the array
'
' Inputs:    index : The index number of the item to be removed
'
' Returns:   N/A
'*****************************************************
Public Function RemoveItem(Index As Integer)
Dim i As Integer
  TestBounds (Index)
  
  If strType = "s" Then
  
    If Index = UBound(strArray) - 1 Then
      ReDim Preserve strArray(UBound(strArray) - 1)
    Else
      For i = Index To UBound(strArray) - 2
        strArray(i) = strArray(i + 1)
      Next i
      ReDim Preserve strArray(UBound(strArray) - 1)
    End If
    
    strArray(UBound(strArray)) = ""
  End If
  
  If strType = "i" Then
    
    If Index = UBound(iArray) - 1 Then
      ReDim Preserve iArray(UBound(iArray) - 1)
    Else
      For i = Index To UBound(iArray) - 2
        iArray(i) = iArray(i + 1)
      Next i
      ReDim Preserve iArray(UBound(iArray) - 1)
    End If
    iArray(UBound(iArray)) = 0
    
  End If
End Function

'*****************************************************
' But:       Checks if the index of the item is withing
'            the bounds of the array (upper and lower)
'
' Inputs:    index : The index number of the item to be checked
'
' Returns:   N/A
'*****************************************************
Private Sub TestBounds(Index As Integer)
Dim Error As Boolean
Error = False

  If Index < 0 Then Error = True
  
  If Index > ListCount() - 1 Then Error = True
  
  If Error = True Then
    MsgBox ListCount() - 1
    MsgBox "Out of bounds Arrays exception!" + Chr(10) + Chr(13) + "The application will now end.", vbCritical, "Array Error"
  End If

End Sub

'*****************************************************
' But:       Transfers the content of an item to an objects
'            and clears it before
'
' Inputs:    lst : The target object
'
' Returns:   N/A
'*****************************************************
Public Sub Transfer_ListBox(lst As Variant)
Dim i As Integer
  lst.Clear
  
  If strType = "s" Then
    For i = 0 To UBound(strArray)
      lst.AddItem strArray(i)
    Next i
  End If
  
  If strType = "i" Then
    For i = 0 To UBound(iArray)
      lst.AddItem iArray(i)
    Next i
  End If
End Sub

'*****************************************************
' But:       Transfers the content of an item to an objects
'
' Inputs:    lst : The target object
'
' Returns:   N/A
'*****************************************************
Public Sub ADD_Transfer_ListBox(lst As Variant)
Dim i As Integer
  
  If strType = "s" Then
    For i = 0 To UBound(strArray) - 1
      lst.AddItem strArray(i)
    Next i
  End If
  
  If strType = "i" Then
    For i = 0 To UBound(iArray) - 1
      lst.AddItem iArray(i)
    Next i
  End If
End Sub

Public Sub Assign(Original As Easy_Array)
Dim i As Integer
  If strType = "s" Then
    ReDim strArray(Original.ListCount)
    
    For i = 0 To Original.ListCount - 1
      strArray(i) = Original.List(i)
    Next i
  End If
  
End Sub
